﻿import com.kampei.image.MotionDetector;
import mx.utils.Delegate;
import flash.display.BitmapData;

stop();

md = new MotionDetector(320, 240, 2/3, 30);
//md.addEventListener("update", Delegate.create(this, onUpdate));
md.addEventListener("create", Delegate.create(this, onCreate));
md.addEventListener("stay", Delegate.create(this, onStay));
md.addEventListener("move", Delegate.create(this, onMove));
md.addEventListener("disappear", Delegate.create(this, onDisappear));
md.addEventListener("integrate", Delegate.create(this, onIntegrate));
md.startDetect(vi_mc);


showInput(input_group.selection);

// input
input_group.addEventListener("click", Delegate.create(this, onChangeInput));
function onChangeInput(e){
	showInput(e.target.selection);
}
function showInput(rb){
	vi_mc.gotoAndStop(2);
	vi_mc.gotoAndStop(1);
	if(rb == video_rb){
		nc = new NetConnection();
		nc.connect(null);
		ns = new NetStream(nc);
		vi_mc.vi.attachVideo(ns);
		ns.play("testmov.flv");
	}else{
		ns.play(false);
		ns.close();
		nc.close();
		cam = Camera.get();
		cam.setMode(320, 240, 12);
		vi_mc.vi.attachVideo(cam);
	}
}


//min_size_new_rect_rate
min_size_slide.setValue(md.min_size_new_rect_rate * 100);
min_size_txt.text = md.min_size_new_rect_rate;
min_size_slide.setChangeHandler("onChangeMinSize", this);
function  onChangeMinSize(){
	var val = Math.round(min_size_slide.getValue()) / 100
	min_size_txt.text = val;
	md.min_size_new_rect_rate = val;
}

//rect_life
life_stepper.value = md.rect_life;
life_stepper.addEventListener("change", Delegate.create(this, onChangeMotionLife));
function onChangeMotionLife(e){
	md.rect_life = life_stepper.value;
}

//threshold
threshold_slider.setValue(md.threshold & 0xff);
threshold_txt.text = getHex(md.threshold);
threshold_slider.setChangeHandler("onChangeThreshold", this);
function  onChangeThreshold(){
	var val = Math.round(threshold_slider.getValue());
	var rgbNum = 0xff<<24 | val<<16 | val<<8 | val;
	md.threshold = rgbNum;
	threshold_txt.text = getHex(rgbNum);
}
function getHex(num:Number):String {
	var arr:Array = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"];
	var res:Array = [];
	while (true) {
		res.unshift(arr[num & 0xf]);
		num >>>= 4;
		if (num == 0) break;
	}
	return res.join("");
}

//noize_min_pix
noise_stepper.value = md.noize_min_pix;
noise_stepper.addEventListener("change", Delegate.create(this, onChangeNoize));
function onChangeNoize(e){
	md.noize_min_pix = noise_stepper.value;
}

//rect_inflation
inflation_stepper.value = md.rect_inflation;
inflation_stepper.addEventListener("change", Delegate.create(this, onChangeInflation));
function onChangeInflation(e){
	md.rect_inflation = inflation_stepper.value;
}




dump_bmp1 = new BitmapData(sa_mc1._width, sa_mc1._height, false);
dump_bmp2 = new BitmapData(sa_mc2._width, sa_mc2._height, false);
sa_mc1.attachBitmap(dump_bmp1, 0);
sa_mc2.attachBitmap(dump_bmp2, 0);
md.dumpDiff = Delegate.create(this, function(bmp){dump_bmp1.draw(bmp)} );
md.dumpLabel = Delegate.create(this, function(bmp){dump_bmp2.draw(bmp)} );

marks = [];
this.createEmptyMovieClip("marks_mc", 1);
this.createEmptyMovieClip("markContainer", 2);
marks_mc.depthNow = 0;

function onUpdate(e){
	resetMarks();
	var tgt = e.target.rectDump0;
	for(var i=0; i<tgt.length; i++){
		showMark(tgt[i], "rect_mark");
	}
	var tgt = e.target.rectDump1;
	for(var i=0; i<tgt.length; i++){
		showMark(tgt[i], "union_mark");
	}
}
function onCreate(e){
	//trace("onCreate:" + e.id + ": " + e.target.toString());
	//attachMovie：ライブラリからシンボルを取得し、ムービークリップに割り当てる
	var tracker = markContainer.attachMovie("tracker", "tracker" + e.id, e.id);
	tracker.rects = [];
	tracker.id_txt.text= e.id;
	trackRect(tracker, e.target);
}
function onStay(e){
	//trace("onStay:" + e.id + ": " + e.target.toString());
	trackRect(markContainer["tracker"+e.id], e.target);
}
function onMove(e){
	//trace("onMove:" + e.id + ": " + e.target.toString());
	trackRect(markContainer["tracker"+e.id], e.target);
}
function onDisappear(e){
	//trace("onDisappear:" + e.id + ": " + e.target.toString());
	clearRect(markContainer["tracker"+e.id])
}
function onIntegrate(e){
	//trace("onIntegrate:" + e.id + ": " + e.target.toString());
	clearRect(markContainer["tracker"+e.id])
}

function trackRect(tracker, rect){
	tracker._x = rect.x;
	tracker._y = rect.y;
	tracker._xscale = rect.width;
	tracker._yscale = rect.height;
}
function clearRect(tracker){
	tracker.removeMovieClip();
}

function showMark(rct, nam){
	var resolution_rate = 2/3;
	var d = marks_mc.depthNow++;
	var mark = marks_mc.attachMovie(nam, "m"+d, d);
	mark._x = Math.round(rct.x / resolution_rate);
	mark._y = Math.round(rct.y / resolution_rate);
	mark._xscale = Math.round(rct.width / resolution_rate);
	mark._yscale = Math.round(rct.height / resolution_rate);
	marks.push(mark);
}
function resetMarks(){
	for(var i in marks){
		marks[i].removeMovieClip();
	}
	marks = [];
}